# HighPoint tarball used --
# RR64xl_Linux_Src_v1.4.0_16_09_20.tar.gz

# Define the kmod package name here.
%define kmod_name rr64xl

# Define the bundle name and source extra index data here.
%define bundle_name rr64xl-linux-src
%define extid 16_09_20

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 3.10.0-862.el7.%{_target_cpu}}

Name:    %{kmod_name}-kmod
Version: 1.4.0
Release: 1%{?dist}
Group:   System Environment/Kernel
License: HighPoint
Summary: %{kmod_name} kernel module(s)
URL:     http://www.highpoint-tech.com/

BuildRequires: redhat-rpm-config, perl
ExclusiveArch: x86_64

# Sources.
Source0:  www.highpoint-tech.com/BIOS_Driver/RR64xL/Linux/RR64xl_Linux_Src_v%{version}_%{extid}.tar.gz
Source5:  GPL-v2.0.txt
Source10: kmodtool-%{kmod_name}-el7.sh
Source15: rr64xl-modules

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion} "")}

# Disable the building of the debug package(s).
%define debug_package %{nil}

%description
This package provides the HighPoint RocketRAID %{kmod_name} kernel module(s).
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -n %{bundle_name}-v%{version}
echo "override rr640l * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf

%build
pushd product/%{kmod_name}/linux >/dev/null
%{__make} KERNELDIR=%{_usrsrc}/kernels/%{kversion}
popd >/dev/null

%install
%{__install} -d %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} product/%{kmod_name}/linux/rr640l.ko %{buildroot}/lib/modules/%{kversion}/extra/%{kmod_name}/
%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
%{__install} -d %{buildroot}%{_sysconfdir}/sysconfig/modules/
%{__install} %{SOURCE15} %{buildroot}%{_sysconfdir}/sysconfig/modules/%{kmod_name}.modules
%{__install} -d %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} README %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/
%{__install} %{SOURCE5} %{buildroot}%{_defaultdocdir}/kmod-%{kmod_name}-%{version}/

# Strip the modules(s).
find %{buildroot} -type f -name \*.ko -exec %{__strip} --strip-debug \{\} \;

# Sign the modules(s).
%if %{?_with_modsign:1}%{!?_with_modsign:0}
# If the module signing keys are not defined, define them here.
%{!?privkey: %define privkey %{_sysconfdir}/pki/SECURE-BOOT-KEY.priv}
%{!?pubkey: %define pubkey %{_sysconfdir}/pki/SECURE-BOOT-KEY.der}
for module in $(find %{buildroot} -type f -name \*.ko);
do %{__perl} /usr/src/kernels/%{kversion}/scripts/sign-file \
    sha256 %{privkey} %{pubkey} $module;
done
%endif

%clean
%{__rm} -rf %{buildroot}

%changelog
* Fri Apr 13 2018 Akan Bartlett <ajb@elrepo.org> - 1.4.0-1.el7_5
- Updated to version 1.4.0
- Rebuilt against RHEL 7.5 kernel

* Thu Mar 05 2015 Philip J Perry <phil@elrepo.org> - 1.3-3
- Rebuilt against RHEL 7.1 kernel

* Sun Sep 07 2014 Akemi Yagi <toracat@elrepo.org> - 1.3-2
- Patch for kernel 3.11 added.

* Sun Sep 07 2014 Alan Bartlett <ajb@elrepo.org> - 1.3-1
- Initial el7 build of the kmod package.
